
// -- Read Functions
BfsHandle 				bfs_open 						(char * fileName, char * access);
int 					bfs_close 						(BfsHandle handle);
int 					bfs_getSignature 				(BfsHandle file, char *string, int len);
int 					bfs_getDataOrigin 				(BfsHandle file, char *string, int len);
int 					bfs_getApplication 				(BfsHandle file, char *string, int len);
int 					bfs_getDescription 				(BfsHandle file, char *string, int len);
double 					bfs_readSubfile 				(BfsHandle handle, int index);
double 					bfs_getTValue 					(BfsHandle handle, int index);
int 					bfs_getIndex 					(BfsHandle handle, double tValue);
double 					bfs_getCurrentTValue 			(BfsHandle handle);
int 					bfs_getCurrentIndex 			(BfsHandle handle);
int 					bfs_getFlags 					(BfsHandle handle);
int 					bfs_getNumberOfSubfiles 		(BfsHandle handle);
int 					bfs_isReadOnly					(BfsHandle handle);
char* 					bfs_getFileName 				(BfsHandle handle);

DataBlockHandle 		bfs_getHeaderDataBlock 			(BfsHandle handle);
DataBlockHandle 		bfs_getSubfileDataBlock 		(BfsHandle handle);


DataDescriptorHandle 	bfs_getDataDescriptorByIndex 	(DataBlockHandle handle, int index);
int 					bfs_getDataDescriptorNbrEntries (DataBlockHandle handle);
int 					bfs_getParamIndex				(DataBlockHandle handle, char *paramName);
int 					bfs_readParam 					(DataBlockHandle handle, char * paramName, int paramStartIndex, void * value, int length);
int 					bfs_readParamByIndex 			(DataBlockHandle handle, int index, int paramStartIndex,  void * value, int length);
int 					bfs_readAsciiString 			(DataBlockHandle handle, char * paramName, char *string, int len);
int 					bfs_readAsciiStringByIndex 		(DataBlockHandle handle, int index, char *string, int len);
int 					bfs_readString 					(DataBlockHandle handle, char * paramName, char *string, int len);
int 					bfs_readStringByIndex 			(DataBlockHandle handle, int index, char *string, int len);
int 					bfs_readAxis 					(DataBlockHandle handle, char * paramName, int axis, int axisStartIndex, void * axisvalue, int length);
DataDescriptorHandle 	bfs_getDataDescriptor 			(DataBlockHandle handle, char * paramName);

int 					bfs_getNbrDims 					(DataDescriptorHandle handle);
int 					bfs_getAxisName 				(DataDescriptorHandle handle, int dimNo, char *string, int len);
int 					bfs_getName 					(DataDescriptorHandle handle, char *string, int len);
int 					bfs_getAxisNPts 				(DataDescriptorHandle handle, int dimNo);
int 					bfs_getAxisType 				(DataDescriptorHandle handle, int dimNo);
int 					bfs_getAxisUnits 				(DataDescriptorHandle handle, int dimNo, char *string, int len);
double 					bfs_getAxisMinValue 			(DataDescriptorHandle handle, int dimNo);
double 					bfs_getAxisMaxValue 			(DataDescriptorHandle handle, int dimNo);

int 					bfs_getParamTypeFromIndexOrName	(DataBlockHandle handle, int index);
int 					bfs_getParamTypeFromIndexOrName (DataBlockHandle handle, char* paramName);
int 					bfs_getParamIndexFromName		(DataBlockHandle handle, char* paramName);
int 					bfs_paramtype_numbytes			(int paramtype);
void* 					bfs_allocate_param_memory		(int paramtype, int numparam);
void 					bfs_delete_param_memory			(void* memory);

DataDirectoryHandle 	bfs_getDataDirectory 			(DataBlockHandle handle);
DataDescriptorHandle 	bfs_getDataDescriptorFromDD 	(DataDirectoryHandle handle, char * paramName)

// -- Write Functions
BfsHandle 				bfs_create 						(char * fileName, char * dataOrigin, char * application,  char * fileDescription, DataDirectoryHandle headerDirectory, DataDirectoryHandle subfileDirectory, int estimatedNbrSubfiles, int creationFlags);
int 					bfs_writeSubfile 				(BfsHandle handle, int index, double tValue);
int 					bfs_deleteSubfiles				(BfsHandle handle, int firstSubfile, int lastSubfile);
int 					bfs_keepSubfiles 				(BfsHandle handle, int firstSubfile, int lastSubfile);
int 					bfs_addToFactory 				(char * fileName, char * name);
void 					bfs_destroyFactory 				(void);
DataDirectoryHandle 	bfs_factory 					(char * name);
int 					bfs_addEntry 					(DataDirectoryHandle handleDir, DataDescriptorHandle handleDd);
DataDescriptorHandle 	bfs_createDataDescriptor	 	(char *paramName, int nbrDim);
DataDirectoryHandle 	bfs_createDataDirectory 		(int nbrOfEntries);
int 					bfs_writeParam 					(DataBlockHandle handle, char * paramName, int paramStartIndex, void * writevalue, int length);
int 					bfs_writeParamByIndex 			(DataBlockHandle handle, int index, int paramStartIndex, void * writevalue, int length);
int 					bfs_writeAsciiString 			(DataBlockHandle handle, char * paramName, char * value);
int 					bfs_writeString 				(DataBlockHandle handle, char * paramName, char * value);
int 					bfs_writeAxis 					(DataBlockHandle handle, char * paramName, int axis, int axisStartIndex, void * axiswritevalue, int length);
int 					bfs_setAxisName 				(DataDescriptorHandle handle, int dimNo, char *paramName);
int 					bfs_setAxisNPts 				(DataDescriptorHandle handle, int dimNo, int axisNPts);
int 					bfs_setAxisType 				(DataDescriptorHandle handle, int dimNo, int axisType);
int 					bfs_setAxisUnits 				(DataDescriptorHandle handle, int dimNo, char *paramName);
int 					bfs_setAxisMaxValue 			(DataDescriptorHandle handle,
int 					bfs_setAxisMinValue 			(DataDescriptorHandle handle, int dimNo, double axisMinValue);

